
unit SingleDbf; interface

{ ⥭     ࠡ    ଠ .DBF }
{ ⮩ ਠ: ⥭   ப       }
{ ࠧ   .    㬥  1       }
{  ࣥ ஢, ࣠ pm@8552.kurgan.su }
{   쬥,  ⮫쪮  ७樥 }

uses Objects;

type
  T32Byte = record
     case Byte of
       1: (B: array[1..32] of Byte;);
       2: (W: array[1..16] of Word);
       3: (L: array[1..8]  of LongInt);
   end;

  PField = ^TField;
  TField = object(TObject)
    Name: array[1..10] of Char;  {   }
    Offs: Word;        { 饭   }
    Len: Byte;         {   }
    Id: Char;          { : 'C'-Character }
                       {      'N'-Numeric   }
                       {      'D'-Date      }
                       {      'L'-Logical   }
                       {      'M'-Memo      }
    constructor Init (const A: T32Byte); { 32  ᠭ  }
  end;

  TFieldArray = array[1..$FFF0 div SizeOf(TField)] of TField;

  PSingleDBF = ^TSingleDBF;
  TSingleDBF = object(TObject)
    CountRecs: LongInt;       { ᫮ ᥩ }
    SizeRec: Word;            {   }
    CountFields: Word;        { ᫮  }
    Change: Boolean;

    constructor Init (const AName: FNameStr);
    destructor  Done; virtual;
    procedure GetDate (var Day, Month, Year: Byte); { 頥   ६ ᮧ 䠩 }
    procedure SetDate (Day, Month, Year: Byte);     { ⠭  }
    function NameField (Index: Word): PChar;    {     }
    function LenFieldName (AName: PChar): Byte; {       }
    function LenFieldIndex (Index: Word): Byte; {       }
    function IdFieldName (AName: PChar): Char;  {     (ᬮ ),  㤠 #0 }
    function IdFieldIndex (Index: Word): Char;  {   (  ᬮ ),  㤠 #0  }

      { ⥭   ஬ Num    AName }
    function GetRecName (Num: LongInt; AName: PChar): string;

      { ⥭   ஬ Num    Index }
    function GetRecIndex (Num: LongInt; Index: Word): string;

      { ⥭   ஬ Num   Field }
    function GetRecField (Num: LongInt; Field: PField): string;
    function IsDelRec (Num: LongInt): Boolean; { ஢ઠ   祭  㤠 }

      {    ஬ Num    AName }
    procedure SetRecName (Num: LongInt; AName: PChar; const Data: string);

      {    ஬ Num    Index }
    procedure SetRecIndex (Num: LongInt; Index: Word; const Data: string);

      {    ஬ Num   Field }
    procedure SetRecField (Num: LongInt; Field: PField; Data: string); virtual;
  private
    Fields: ^TFieldArray;     { ᨢ  }
    Stream: PStream;          { ᪮ 䠩 }
    SizeHeader: Word;         {   }
    function  GetField (AName: PChar): PField; { 祭 뫪   }
  end;

type
  PFieldItem = ^TFieldItem;
  TFieldItem = record
    Next: PFieldItem;
    FName: PChar;          {   }
    FType: Char;           {   }
    FLen: Word;            {   (訩  - ᫮ ᫥ ⮩) }
  end;

function NewFieldItem (AName: PChar; AType: Char; ALen: Word;
                       ANext: PFieldItem): PFieldItem;

type
    {  ࠡ  楫묨 ﬨ    }
  PFullRecDBF = ^TFullRecDBF;
  TFullRecDBF = object(TSingleDBF)
    ChangeCountRecs: Boolean;  { ਧ 㢥祭  }

    constructor Create (const AName: string; AHead: PFieldItem);
    destructor Done; virtual;
    function CreateFullRec: PChar;  {   (஡)   }

      { 㦠  ᥩ  (Rec  ⢮  맮) }
    procedure LoadFullRec (Num: LongInt; Rec: PChar); {  - ⭠  CreateFullRec }
    procedure EraseFullRec (Rec: PChar); { 㭪樨  GetRec..  SetRec.. ,  ࠡ   Rec }
    function GetFullRecName (Rec, AName: PChar): string;
    function GetFullRecIndex (Rec: PChar; Index: Word): string;
    function GetFullRecField (Rec: PChar; Field: PField): string;
    procedure SetFullRecName  (Rec, AName: PChar; const Data: string);
    procedure SetFullRecIndex  (Rec: PChar; Index: Word; const Data: string);
    procedure SetFullRecField  (Rec: PChar; Field: PField; Data: string); {  ࠡ⠭  }
    procedure StoreFullRec (Num: LongInt; Rec: PChar); virtual;
    procedure SetRecField (Num: LongInt; Field: PField; Data: string); virtual;
  end;

type
    {   ⥭ ᥩ   EMS  ᪢  }
  PExpMemDBF = ^TExpMemDBF;
  TExpMemDBF = object(TFullRecDBF)
    constructor Init (const AName: FNameStr);
    constructor Create (const AName: string; AHead: PFieldItem);
    destructor  Done; virtual; {    ஬ Num   Field }
    procedure SetRecField (Num: LongInt; Field: PField; Data: string); virtual; {  ࠡ⠭  }
    procedure StoreFullRec (Num: LongInt; Rec: PChar); virtual;
  private
    OldStream: PStream;
  end;

type
  PBufferedDBF = ^TBufferedDBF;
  TBufferedDBF = object(TFullRecDBF)
    constructor Init (const AName: FNameStr; BufSize: Word);
    constructor Create (const AName: string; AHead: PFieldItem; BufSize: Word);
  end;

{}
                                 implementation
{}

uses PasString, Dos, Strings;


 { ८ࠧ   ᨬ  ⨯    }
procedure ConvertRecData (var Data: string; FieldType: Char; FieldLen: Byte);
begin
  Data := AllTrim(Data);
  case FieldType of
    'C', 'D', 'M': Data := PadR(Data, FieldLen); { 塞 ஡ ࠢ }
    'N': Data := PadL(Data, FieldLen);  { ᫮ 塞 ஡ ᫥ }
    'L': case UpCase(Data[1]) of        { ᪨-ᥭ 㪢 }
           'T', 'Y': Data := 'T';
           else Data := 'F'
         end;
    else Data := FillStr(FieldLen);
  end;
end;


constructor TField.Init (const A: T32Byte);
  var
    R: record                         { ଠ ⥫  }
      N: array[1..10] of Char;
      Empty1: Byte;
      I: Char;   { Id }
      O: Word;   { Offset }
      Empty2: Word;
      L: Byte;   { Length }
    end absolute A;
    L: Word;
begin
  Offs := R.O;
  Id := R.I;
  Len := R.L;
  StrLCopy(PChar(@Name), PChar(@R.N), 10);
end;


constructor TSingleDBF.Init (const AName: FNameStr);
  var
    R: T32Byte;
    Offs: Word;
    i: Word;
begin
  inherited Init;
  Stream := New(PDosStream, Init(AName, stOpen));
  if Stream^.Status <> stOk then begin
    Done;
    Fail;
  end;
  Stream^.Read(R, SizeOf(R));  { ⥭  }
  CountRecs := R.L[2];   {  뢠 ଠ  }
  SizeHeader := R.W[5];
  SizeRec := R.W[6];
  CountFields := SizeHeader div 32-1;
  GetMem(Fields, CountFields*SizeOf(TField));
  Offs := 0;   {  ᬥ饭   -뢠 ᠬ }
  for i := 1 to CountFields do begin
    Stream^.Read(R, SizeOf(R));
    R.W[7] := Offs;
    Inc(Offs, R.B[17]);
    Fields^[i].Init(R);
  end;
end;

destructor  TSingleDBF.Done;
  var
    Y,M,D,DW: Word;
begin
  if Change then begin  { 뫨  - ⠢   }
    Dos.GetDate(Y,M,D,DW);
    if Y >= 2000 then
      Dec(Y, 100);
    SetDate(D,M,Y-1900);
  end;
  if Assigned(Stream) then
    Stream^.Free;
  if Assigned(Fields) then
    FreeMem(Fields, CountFields*SizeOf(TField));
end;

procedure TSingleDBF.GetDate (var Day, Month, Year: Byte);
begin
  Stream^.Seek(1);
  Stream^.Read(Year, 1);
  Stream^.Read(Month, 1);
  Stream^.Read(Day, 1);
end;

procedure TSingleDBF.SetDate (Day, Month, Year: Byte);
begin
  Stream^.Seek(1);
  Stream^.Write(Year, 1);
  Stream^.Write(Month, 1);
  Stream^.Write(Day, 1);
end;

function TSingleDBF.NameField (Index: Word): PChar;
begin
  if (Index > 0) and (Index <= CountFields) then
    NameField := PChar(@Fields^[Index].Name)
  else
    NameField := nil;
end;

function TSingleDBF.LenFieldName (AName: PChar): Byte;
  var
    P: PField;
begin
  P := GetField(AName);
  if Assigned(P) then
    LenFieldName := P^.Len
  else
    LenFieldName := 0;
end;

function TSingleDBF.LenFieldIndex (Index: Word): Byte;
begin
  if (Index > 0) and (Index <= CountFields) then
    LenFieldIndex := Fields^[Index].Len
  else
    LenFieldIndex := 0
end;

function TSingleDBF.IdFieldName (AName: PChar): Char;
  var
    P: PField;
begin
  P := GetField(AName);
  if Assigned(P) then
    IdFieldName := P^.Id
  else
    IdFieldName := #0
end;

function TSingleDBF.IdFieldIndex (Index: Word): Char;
begin
  if (Index > 0) and (Index <= CountFields) then
    IdFieldIndex := Fields^[Index].Id
  else
    IdFieldIndex := #0
end;

function TSingleDBF.GetRecName (Num: LongInt; AName: PChar): string;
begin
  GetRecName := GetRecField(Num, GetField(AName));
end;

function TSingleDBF.GetRecIndex (Num: LongInt; Index: Word): string;
begin
  if (Index > 0) and (Index <= CountFields) then
    GetRecIndex := GetRecField(Num, @Fields^[Index])
  else
    GetRecIndex := GetRecField(Num, nil)
end;

function TSingleDBF.GetRecField (Num: LongInt; Field: PField): string;
  var
    P: PString;
begin
  if not Assigned(Field) then begin
    GetRecField := '';
    Exit;
  end;
  Stream^.Seek(SizeHeader+Field^.Offs+(Num-1)*SizeRec+1);
  asm
      les ax,@Result
      mov WORD PTR P[0],ax
      mov WORD PTR P[2],es
  end;
  Stream^.Read(P^[1], Field^.Len);
  P^[0] := Chr(Field^.Len);
end;

function TSingleDBF.IsDelRec (Num: LongInt): Boolean;
  var
    Cc: Char;
begin
  Stream^.Seek(SizeHeader+(Num-1)*SizeRec);
  Stream^.Read(Cc, SizeOf(Cc));
  IsDelRec := (Cc = '*');
end;

procedure TSingleDBF.SetRecName (Num: LongInt; AName: PChar; const Data: string);
begin
  SetRecField(Num, GetField(AName), Data);
end;

procedure TSingleDBF.SetRecIndex (Num: LongInt; Index: Word; const Data: string);
begin
  if (Index > 0) and (Index <= CountFields) then
    SetRecField(Num, @Fields^[Index], Data)
  else
    SetRecField(Num, nil, Data)
end;

procedure TSingleDBF.SetRecField (Num: LongInt; Field: PField; Data: string);
begin
  if not Assigned(Field) then
    Exit;
  ConvertRecData(Data, Field^.Id, Field^.Len);
  Stream^.Seek(SizeHeader+Field^.Offs+(Num-1)*SizeRec+1);
  Stream^.Write(Data[1], Length(Data));
  Change := TRUE;
end;

function  TSingleDBF.GetField (AName: PChar): PField;
  var
    i: Word;
    Q: PField;
begin
  if Assigned(AName) then
    for i := 1 to CountFields do begin
      Q := @Fields^[i];
      if StrLIComp(PChar(@Q^.Name), AName, 10) = 0 then begin
        GetField := Q;
        Exit
      end;
  end;
  GetField := nil;
end;

constructor TFullRecDBF.Create (const AName: string; AHead: PFieldItem);
  var
    R: T32Byte;
    i, j: Word;
    Count: Byte;
    P: PFieldItem;
begin
  if AHead = nil then
    Fail;
  TObject.Init;
  Stream := New(PDosStream, Init(AName, stCreate));
  if Stream^.Status <> stOk then
    Fail;
  FillChar(R, SizeOf(R), 0);
  R.B[1] := 3;  { ਧ .DBF 䠩 }
  Count := 0;   { ⢮  }
  P := AHead;
  while Assigned(P) do begin
    Inc(Count);
    Inc(R.W[6], Lo(P^.FLen)); { R.W[6] - ࠧ  }
    P := P^.Next;
  end;
  Inc(R.W[6]);  {  ࠧ    ਧ 㤠 }
  SizeRec := R.W[6];
  CountFields := Count;
  SizeHeader := (Count+1)*32+1;  { +32*᫮ + 砭 (#13)}
  R.W[5] := SizeHeader;
  Stream^.Write(R, SizeOf(R));
  if Stream^.Status <> stOk then
    Fail;
  GetMem(Fields, Count*SizeOf(TField));
  P := AHead;
  j := 0;
  for i := 1 to Count do begin
    FillChar(R, SizeOf(R), 0);
    StrLCopy(PChar(Addr(R)), P^.FName, 10);
    R.B[12] := Ord(P^.FType);
    R.B[17] := Lo(P^.FLen);
    R.B[18] := Hi(P^.FLen);
    R.B[13] := Lo(j);
    R.B[14] := Hi(j);
    Inc(j, Lo(P^.FLen));
    AHead := P^.Next;
    Dispose(P);
    P := AHead;
    Fields^[i].Init(R);
    Stream^.Write(R, SizeOf(R));
  end;
  j := 13;
  Stream^.Write(j, 1);
  Change := TRUE;
end;


destructor TFullRecDBF.Done;
begin
  if ChangeCountRecs then begin
    Stream^.Seek(4);
    Stream^.Write(CountRecs, SizeOf(CountRecs));
    Stream^.Seek(SizeHeader+CountRecs*SizeRec);
    Stream^.Truncate;
  end;
  inherited Done;
end;


function TFullRecDBF.CreateFullRec: PChar;
  var
    Rec: PChar;
begin
  GetMem(Rec, SizeRec+1);
  FillChar(Rec^, SizeRec, Blank);
  Rec[SizeRec] := #0;
  CreateFullRec := Rec;
end;

procedure TFullRecDBF.LoadFullRec (Num: LongInt; Rec: PChar);
begin
  Stream^.Seek(SizeHeader+(Num-1)*SizeRec);
  Stream^.Read(Rec^, SizeRec);
end;

procedure TFullRecDBF.EraseFullRec (Rec: PChar);
begin
  FreeMem(Rec, SizeRec+1);
end;

function TFullRecDBF.GetFullRecName (Rec, AName: PChar): string;
begin
  GetFullRecName := GetFullRecField(Rec, GetField(AName));
end;

function TFullRecDBF.GetFullRecIndex (Rec: PChar; Index: Word): string;
begin
  if (Index > 0) and (Index <= CountFields) then
    GetFullRecIndex := GetFullRecField(Rec, @Fields^[Index])
  else
    GetFullRecIndex := GetFullRecField(Rec, nil)
end;

function TFullRecDBF.GetFullRecField (Rec: PChar; Field: PField): string;
  var
    P: PString;
begin
  if not Assigned(Field) then
    GetFullRecField := ''
  else begin
    asm
       les ax,@Result
       mov WORD PTR P[0],ax
       mov WORD PTR P[2],es
    end;
    Move(Rec[Field^.Offs+1], P^[1], Field^.Len);
    P^[0] := Chr(Field^.Len);
  end;
end;

procedure TFullRecDBF.SetFullRecName  (Rec, AName: PChar; const Data: string);
begin
  SetFullRecField(Rec, GetField(AName), Data);
end;

procedure TFullRecDBF.SetFullRecIndex  (Rec: PChar; Index: Word; const Data: string);
begin
  if (Index > 0) and (Index <= CountFields) then
    SetFullRecField(Rec, @Fields^[Index], Data)
  else
    SetFullRecField(Rec, nil, Data)
end;

procedure TFullRecDBF.SetFullRecField  (Rec: PChar; Field: PField; Data: string);
begin
  if not Assigned(Field) then
    Exit;
  ConvertRecData(Data, Field^.Id, Field^.Len);
  Move(Data[1], Rec[Field^.Offs+1], Length(Data));
end;

procedure TFullRecDBF.StoreFullRec (Num: LongInt; Rec: PChar);
begin
  if Num > CountRecs then begin
    ChangeCountRecs := TRUE;
    CountRecs := Num;
  end;
  Stream^.Seek(SizeHeader+(Num-1)*SizeRec);
  Stream^.Write(Rec^, SizeRec);
  Change := TRUE;
end;

procedure TFullRecDBF.SetRecField (Num: LongInt; Field: PField; Data: string);
begin
  if not Assigned(Field) then
    Exit;
  if Num > CountRecs then begin
    ChangeCountRecs := TRUE;
    CountRecs := Num;
    Stream^.Seek(SizeHeader+(Num-1)*SizeRec);
    Stream^.Write(PadFillChar, 1);
  end;
  Stream^.Seek(SizeHeader+Field^.Offs+(Num-1)*SizeRec+1);
  ConvertRecData(Data, Field^.Id, Field^.Len);
  Stream^.Write(Data[1], Length(Data));
  Change := TRUE;
end;

constructor TExpMemDBF.Init (const AName: FNameStr);
  var
    EMS: PStream;
begin
  if not inherited Init (AName) then
    Fail;
  EMS := New(PEmsStream, Init(Stream^.GetSize, MaxLongInt));
  if EMS^.Status <> stOk then begin
    Dispose(EMS, Done);
    Exit;
  end;
  Stream^.Seek(0);
  EMS^.CopyFrom(Stream^, Stream^.GetSize);
  if EMS^.Status <> stOk then begin
    Dispose(EMS, Done);
    Exit;
  end;
  OldStream := Stream;
  Stream := EMS;
end;

constructor TExpMemDBF.Create (const AName: string; AHead: PFieldItem);
  var
    EMS: PStream;
begin
  if not inherited Create (AName, AHead) then
    Fail;
  EMS := New(PEmsStream, Init(Stream^.GetSize, MaxLongInt));
  if EMS^.Status <> stOk then begin
    Dispose(EMS, Done);
    Exit;
  end;
  Stream^.Seek(0);
  EMS^.CopyFrom(Stream^, Stream^.GetSize);
  if EMS^.Status <> stOk then begin
    Dispose(EMS, Done);
    Exit;
  end;
  OldStream := Stream;
  Stream := EMS;
end;

destructor  TExpMemDBF.Done;
begin
  if Assigned(Stream) then
    Stream^.Free;
  Stream := OldStream;
  inherited Done;
end;

procedure TExpMemDBF.SetRecField (Num: LongInt; Field: PField; Data: string);
  var
    Temp: PStream;
begin
  inherited SetRecField(Num, Field, Data);
  if Assigned(OldStream) then begin
    Temp := Stream;
    Stream := OldStream;
    inherited SetRecField(Num, Field, Data);
    Stream := OldStream;
  end;
end;

procedure TExpMemDBF.StoreFullRec (Num: LongInt; Rec: PChar);
  var
    Temp: PStream;
begin
  inherited StoreFullRec(Num, Rec);
  if Assigned(OldStream) then begin
    Temp := Stream;
    Stream := OldStream;
    inherited StoreFullRec(Num, Rec);
    Stream := OldStream;
  end;
end;

constructor TBufferedDBF.Init (const AName: FNameStr; BufSize: Word);
  var
    R: T32Byte;
    Offs: Word;
    i: Word;
begin
  if not inherited Init(AName) then
    Fail;
  Stream^.Free;
  Stream := New(PBufStream, Init(AName, stOpen, BufSize));
end;

constructor TBufferedDBF.Create (const AName: string; AHead: PFieldItem;
                BufSize: Word);
begin
  if not inherited Create(AName, AHead) then
    Fail;
  Stream^.Free;
  Stream := New(PBufStream, Init(AName, stOpen, BufSize));
end;

function NewFieldItem (AName: PChar; AType: Char; ALen: Word;
                       ANext: PFieldItem): PFieldItem;
  var
    P: PFieldItem;
begin
  New(P);
  P^.Next := ANext;
  P^.FName := AName;
  P^.FType := AType;
  P^.FLen := ALen;
  NewFieldItem := P;
end;


end.
